; English forum: http://purebasic.myforums.net/viewtopic.php?t=7174&highlight=
; Author: Flype
; Date: 09. August 2003

; Move up or down the elements of a linked list and then display them in a listicongadget.
; Note: Simple PureBasic code example! Could be improved with the use of pointers as you
;       can see in this example:
;
;   Structure ListHeader
;     *NextElement.ListHeader
;     *PreviousElement.ListHeader
;   EndStructure
;
;   *MyElement = @list()-SizeOf(ListHeader)
;
;   ; And you can play with the pointers :)
;
; Works also for structured linked lists, like here:
;   Structure StringList
;     String.s
;     Long.l
;   EndStructure
;   NewList StringListExample.StringList
; 


;/-------------------------------

#NONE   = -1
#BOTTOM = -1
#GT_LIST = 1
#GT_UP   = 2
#GT_DOWN = 3

;/-------------------------------

NewList mylist.s()

For i=0 To 20
  AddElement( mylist() ) : mylist() = "test line n"+Str(i)
Next

;/-------------------------------

Procedure LIST_Fill()
  ClearGadgetItemList( #GT_LIST )
  ResetList( mylist() )
  While NextElement( mylist() )
    AddGadgetItem( #GT_LIST, #BOTTOM, mylist(), 0 )
  Wend
EndProcedure

Procedure LIST_Up()
  position = GetGadgetState( #GT_LIST )
  If position <> #NONE
    SelectElement( mylist(), position )
    element.s = mylist()
    DeleteElement( mylist() )
    InsertElement( mylist() )
    mylist() = element
    LIST_Fill() : SetGadgetItemState( #GT_LIST, position-1, #TRUE )
  EndIf
EndProcedure

Procedure LIST_Down()
  position = GetGadgetState( #GT_LIST )
  If position <> #NONE
    SelectElement( mylist(), position )
    element.s = mylist()
    DeleteElement( mylist() )
    SelectElement( mylist(), position+1 )
    InsertElement( mylist() )
    mylist() = element
    LIST_Fill() : SetGadgetItemState( #GT_LIST, position+1, #TRUE )
  EndIf
EndProcedure

;/-------------------------------

OpenWindow( 0, 200, 200, 500, 400, #PB_Window_SystemMenu, "Nettie Prefs" )
CreateGadgetList( WindowID() )
ListIconGadget( #GT_LIST, 60,5,WindowWidth()-65,WindowHeight()-10, "Item", 110, #PB_ListIcon_AlwaysShowSelection )
ButtonGadget( #GT_UP,   5,   5, 50, 24, "Up"   )
ButtonGadget( #GT_DOWN, 5,  30, 50, 24, "Down" )
LIST_Fill()

;/-------------------------------

Repeat
  Select WaitWindowEvent()
  Case #WM_CLOSE : quit=#TRUE
  Case #PB_Event_Gadget
    Select EventGadgetID()
    Case #GT_UP   : LIST_Up()
    Case #GT_DOWN : LIST_Down()
    EndSelect
  EndSelect
Until quit=#TRUE

;/-------------------------------

End
; ExecutableFormat=
; FirstLine=1
; EnableXP
; EOF