; English forum:
; Author: Freak
; Date: 06. April 2003
;===============================================================================

; Enable Images for a Panel Gadget
; It can be enabled for as many PanelGadgets as needed
; MaxItems is the maximum number of Items your PanelGadget will have.
; If this returns 0, no Images can be added to the Panel
Procedure EnablePanelImages(Gadget.l, MaxItems.l)
  Protected hIml.l
  hIml = ImageList_Create_(16, 16, #ILC_COLOR32|#ILC_MASK, MaxItems, MaxItems)
  If hIml
    SendMessage_(GadgetID(Gadget), #TCM_SETIMAGELIST, 0, hIml)
    ProcedureReturn #TRUE
  Else
    ProcedureReturn #FALSE
  EndIf
EndProcedure

; Add an Image to a Panel Item
; You can call this Function again for the same Item, to set a new Image.
Procedure SetPanelImage(Gadget.l, Position.l, ImageID.l)
  Protected hIml.l, pitem.TC_ITEM
  hIml = SendMessage_(GadgetID(Gadget), #TCM_GETIMAGELIST, 0,0)
  pitem\mask = #TCIF_IMAGE
  SendMessage_(GadgetID(Gadget), #TCM_GETITEM, Position, @pitem)
  If pitem\iImage = 0
    pitem\iImage = ImageList_AddIcon_(hIml, ImageID)
  Else
    pitem\iImage = ImageList_ReplaceIcon_(hIml, pitem\iImage, ImageID)
  EndIf
  SendMessage_(GadgetID(Gadget), #TCM_SETITEM, Position, @pitem)
EndProcedure

;===============================================================================
;- Code Example
;===============================================================================

; Load needed Icons (change the Path for your PB dir)
LoadImage(0, "C:\Programming\PureBasic\Examples\Sources\Data\CdPlayer.ico")
LoadImage(1, "C:\Programming\PureBasic\Examples\Sources\Data\NewProject.ico")
LoadImage(2, "C:\Programming\PureBasic\Examples\Sources\Data\SaveProject.ico")

#Panel = 1

; Create Window
OpenWindow(0,0,0,300,300,#PB_Window_SystemMenu|#PB_Window_Screencentered, "Panel Images")
CreateGadgetList(WindowID())

; Create Panel
PanelGadget(#Panel, 20, 20, 260, 260)
  AddGadgetItem(#Panel, 0, "Item0")
  AddGadgetItem(#Panel, 1, "Item1")
  AddGadgetItem(#Panel, 2, "Item2")   
CloseGadgetList()

; Enable Images for this Panel (only 3 Items)
If EnablePanelImages(#Panel, 3)

  ; Add the loaded Icons to the Panel Items
  SetPanelImage(#Panel, 0, UseImage(0))
  SetPanelImage(#Panel, 1, UseImage(1))
  SetPanelImage(#Panel, 2, UseImage(2))  
  
EndIf

; Wait for Quit
Repeat
Until WaitWindowEvent() = #PB_EventCloseWindow
End

;===============================================================================
; ExecutableFormat=Windows
; CursorPosition=2
; FirstLine=1
; EOF