; English forum: http://purebasic.myforums.net/viewtopic.php?t=7131&highlight=
; Author: Lars Gretnes
; Date: 06. August 2003

; Attention! Needs the archives, pictures from original PureBasic Examples\data directory....

; 
; 
; Keeping constant distance to terrain example 
; by Lars Gretnes, 2003 
; 

#CameraSpeed  = 20 
#WalkSpeed    = 50 

IncludeFile "Screen3DRequester.pb" 

DefType.f KeyX, KeyY, MouseX, MouseY 

If InitEngine3D() 

  Add3DArchive("Data\"          , #PB_3DArchive_FileSystem) 
  Add3DArchive("Data\Skybox.zip", #PB_3DArchive_Zip) 
  
  InitSprite() 
  InitKeyboard() 
  InitMouse() 
  
  If Screen3DRequester() 

    AmbientColor(RGB(255,255,255)) 

    ; load the mesh (robot) 
    LoadMesh(0, "data\Robot.mesh") 
    LoadTexture(2, "data\r2skin.jpg") 
    CreateMaterial (0, TextureID(2)) 
    CreateEntity (0, MeshID(0), MaterialID(0), -1, -2, -3) 
    
    ; load terrain 
    LoadTexture (0, "data\Terrain_Texture.jpg") 
    LoadTexture (1, "data\Terrain_Detail.jpg") 
    CreateMaterial (1, TextureID(0)) 
    AddMaterialLayer(0, TextureID(1), 1) 
    CreateTerrain("data\Terrain.png", MaterialID(1), 40, 1, 40, 0) 

    SkyDome("data\Clouds.jpg", 30) 

    ; create and place the camera 
    CreateCamera(0,0,0,100,100) 
    CameraLocate(0,3700,50,1775) 

    Repeat 
      Screen3DEvents() 

       ; get the key input 
       If ExamineKeyboard() 
        If KeyboardPushed(#PB_Key_Left) 
          KeyX = -#WalkSpeed 
        ElseIf KeyboardPushed(#PB_Key_Right) 
          KeyX = #WalkSpeed 
        Else 
          KeyX = 0 
        EndIf 
                  
        If KeyboardPushed(#PB_Key_Up) 
          KeyY = -#WalkSpeed 
        ElseIf KeyboardPushed(#PB_Key_Down) 
          KeyY = #WalkSpeed 
        Else 
          KeyY = 0 
        EndIf 

      EndIf 
      
      ; get mousemovement 
      If ExamineMouse() 
        MouseX = -(MouseDeltaX()/10)*#CameraSpeed/2 
        MouseY = -(MouseDeltaY()/10)*#CameraSpeed/2 
      EndIf 
      
      ; get the terrain heigh at the player coords 
      ypos = TerrainHeight(CameraX(0) ,CameraZ(0)) + 50 

      ; move the camera, and keep the height at +50 
      RotateCamera (0, MouseX, MouseY, 0) 
      MoveCamera (0, KeyX, 0, KeyY) 
      CameraLocate (0, CameraX(0), ypos, CameraZ(0)) 

      ; render world 
      RenderWorld() 
      FlipBuffers() 

    Until KeyboardPushed(#PB_Key_Escape) 
  EndIf 
    
Else 
  MessageRequester("Error", "The 3D Engine can't be initialized",0) 
EndIf 

; ExecutableFormat=Windows
; FirstLine=1
; DisableDebugger
; EOF