; English forum: http://purebasic.myforums.net/viewtopic.php?t=7431
; Author: Froggerprogger
; Date: 04. September 2003
 
; Creates a .wav testfile with a sinus tone

;-  04.09.03 by Froggerprogger 
;-  04.09.03 by Froggerprogger 
;- 
;-  Tip: You can replace the byte-text-output with the following: 
;- 
;-  WriteLong($46464952) = "RIFF" 
;-  WriteLong($45564157) = "WAVE" 
;-  WriteLong($20746D66) = "fmt " 
;- 
;-  You can even use WriteString("RIFF") and WriteString("WAVEfmt "), because PB doesn't write a 
;-  terminating 0 - but I don't like this way, perhaps it's too easy ;-) 
;- 
;- For further information on the WAV-format look at: http://www.sonicspot.com/guide/wavefiles.html 

#pi = 3.141593                      ; pi 
#fq = 220                           ; frequenz in Hz for sinustone 
#samplerate = 44100                 ; samplerate 
#bitrate = 16                       ; Bits per sample, #bitrate Mod 8 must be 0 ! 
#channels = 2                       ; number of channels 
#secs = 4                           ; time for the sinustone in seconds 
#soundfilename = "wavtest.wav"      ; filename for the soundfile 

avBytesPerSec.l = #channels*#bitrate/8*#samplerate  ; calculate the average bytes per second 

CreateFile(0, #soundfilename) 
  WriteByte(Asc("R"))               ; here you can use WriteLong($46464952) instead - see the tip on top 
  WriteByte(Asc("I")) 
  WriteByte(Asc("F")) 
  WriteByte(Asc("F")) 
  WriteLong(36+avBytesPerSec*#secs) ; normally filesize - 8 Bytes, here a bit tricky, fmt-chunk + data-chunk 

  WriteByte(Asc("W")) 
  WriteByte(Asc("A")) 
  WriteByte(Asc("V")) 
  WriteByte(Asc("E")) 
  
  WriteByte(Asc("f")) 
  WriteByte(Asc("m")) 
  WriteByte(Asc("t")) 
  WriteByte(Asc(" ")) 
  WriteLong(16)                     ; chunk data size 

  WriteWord(1)                      ; compression code 
  WriteWord(#channels)              ; number of channels 
  WriteLong(#samplerate)            ; samplerate 
  WriteLong(avBytesPerSec)          ; average bytes per second, here 2(channels)*2(block align)*44100(samplerate) 
  WriteWord(#bitrate/8*#channels)   ; Block Align ('bytes per sample') 
  WriteWord(#bitrate)               ; Bits per sample 
  WriteByte(Asc("d")) 
  WriteByte(Asc("a")) 
  WriteByte(Asc("t")) 
  WriteByte(Asc("a")) 
  WriteLong(avBytesPerSec*#secs)    ; data chunk size in byes 

  Global  actsamplevalue.w         ; for signed RAW data 
  
  For acttime = 1 To #samplerate * #secs 
    For actchannel = 1 To #channels 
        actsamplevalue = 32767 * Sin(2 * #pi * #fq * acttime / #samplerate) 
        WriteWord(actsamplevalue) 
    Next 
  Next 
CloseFile(0) 

; ExecutableFormat=
; FirstLine=1
; EOF