; English forum:
; Author: fweil
; Date: 08. July 2002
; OS: Windows
; Demo: No


;==========================================================
;
; InputRequesterS is a Requester function displaying a string box
; and returning the entered string.
;
; A title and a default value are passed, and return key or OK button
; allow to return from procedure.
;
; If Escape key is pushed or the requester is closed without return or OK
; validation , the returned value is the default.
;

Procedure.s InputRequesterS(lTitle.s, lDefault.s)
  ;
  ; Constants are set for possible integration
  ;
  #InputRequesterSWID = 99
  #InputRequesterSGID = 198
  lXSize.l = 200
  lYSize.l = 25
  ;
  ; GetSystemMetrics_ API function gives access to screen dimensions
  ;
  If OpenWindow(#InputRequesterSWID, (GetSystemMetrics_(#SM_CXSCREEN) - lXSize) / 2, (GetSystemMetrics_(#SM_CYSCREEN) - lYSize) / 2, lXSize + 40, lYSize, #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget, lTitle)
    AddKeyboardShortcut(#InputRequesterSWID, #PB_Shortcut_Return, 10)
    AddKeyboardShortcut(#InputRequesterSWID, #PB_Shortcut_Escape, 99)
    If CreateGadgetList(WindowID())
      StringGadget(#InputRequesterSGID, 2, 2, lXSize - 4, lYSize - 5, lDefault)
      ButtonGadget(#InputRequesterSGID + 1, lXSize + 5, lYSize - 25, 30, 20, "OK")
    EndIf
    lResult.s = GetGadgetText(#InputRequesterSGID)
    lQuit.l = #FALSE
    Repeat
      Select WaitWindowEvent()
        Case #PB_EventCloseWindow
          lQuit = #TRUE
        Case #PB_EventMenu
          Select EventMenuID()
            Case 10
              lResult = GetGadgetText(#InputRequesterSGID)
              lQuit = #TRUE
            Case 99
              lQuit = #TRUE
          EndSelect
        Case #PB_EventGadget
          Select EventGadgetID()
            Case (#InputRequesterSGID + 1)
              lResult = GetGadgetText(#InputRequesterSGID)
              lQuit = #TRUE
          EndSelect
      EndSelect
    Until lQuit
    RemoveKeyboardShortcut(#InputRequesterSWID, #PB_Shortcut_All)
    CloseWindow(#InputRequesterSWID)
  EndIf
  ProcedureReturn lResult
EndProcedure

;
; InputRequesterSML is a multilined string input requester.
; It is like InputRequesterS but does not return when using the return key
; and allows mulitple lines handling.
;
; Also this requester gives the possibility of resizing to meet user's needs
;
Procedure.s InputRequesterSML(lTitle.s, lDefault.s)
  #InputRequesterSWID = 99
  #InputRequesterSGID = 198
  lXSize.l = 200
  lYSize.l = 80
  If OpenWindow(#InputRequesterSWID, (GetSystemMetrics_(#SM_CXSCREEN) - lXSize) / 2, (GetSystemMetrics_(#SM_CYSCREEN) - lYSize) / 2, lXSize + 40, lYSize, #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_SizeGadget, lTitle)
    AddKeyboardShortcut(#InputRequesterSWID, #PB_Shortcut_Escape, 99)
    If CreateGadgetList(WindowID())
      StringGadget(#InputRequesterSGID, 2, 2, lXSize - 4, lYSize - 5, lDefault, #PB_String_Multiline | #ES_AUTOVSCROLL | #WS_VSCROLL | #WS_HSCROLL)
      ButtonGadget(#InputRequesterSGID + 1, lXSize + 5, lYSize - 25, 30, 20, "OK")
    EndIf
    lResult.s = GetGadgetText(#InputRequesterSGID)
    lQuit.l = #FALSE
    Repeat
      Select WaitWindowEvent()
        Case #PB_EventCloseWindow
          lQuit = #TRUE
        Case #PB_EventMenu
          Select EventMenuID()
            Case 99
              lQuit = #TRUE
          EndSelect
        Case #PB_EventGadget
          Select EventGadgetID()
            Case (#InputRequesterSGID + 1)
              lResult = GetGadgetText(#InputRequesterSGID)
              lQuit = #TRUE
          EndSelect
      EndSelect
      If WindowWidth() <> lXSize + 40 Or WindowHeight() <> lYSize
        lXSize = WindowWidth() - 40
        lYSize = WindowHeight()
        ResizeGadget(#InputRequesterSGID, 2, 2, lXSize - 4, lYSize - 5)
        ResizeGadget(#InputRequesterSGID + 1, lXSize + 5, lYSize - 25, 30, 20)
      EndIf
    Until lQuit
    RemoveKeyboardShortcut(#InputRequesterSWID, #PB_Shortcut_All)
    CloseWindow(#InputRequesterSWID)
  EndIf
  ProcedureReturn lResult
EndProcedure

;
; Main test code
;
sString.s
; sString = InputRequesterS("Enter a text", "Default")
; Debug sString

sString = InputRequesterSML("Enter a text", "Default")
Debug sString

End
;==========================================================

; ExecutableFormat=Windows
; FirstLine=1
; EOF